/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: SystemExitHook.java 1:04:18 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.system.launch;

import org.objectweb.petals.kernel.server.PetalsServer;

/**
 * Hook used to stop Petals on CTRL-C, kill or System.exit()
 * 
 * @author alouis, ddesjardins , rnaudin - eBMWebsourcing
 */
public class SystemExitHook extends Thread {

    private PetalsServer petalsServer;

    public SystemExitHook(PetalsServer petalsServer) {
        super();
        this.petalsServer = petalsServer;
    }

    public void run() {
        System.out.println("Force the stop of Petals");
        try {
            /*
             * remove the stop listener to avoid the remove of this SystemExitHook
             * by the standalone launcher
             */
            petalsServer.removeListener();
            System.out.println("Petals is stopping...");
            petalsServer.triggerStop(false);
            System.out.println("Petals is stopped");
        } catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }

}
